#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
//#define DIV 4

void number_search(IplImage *src_l, int* num_l){
	int f1l,f2l,f3l,f4l,f5l,f6l,f7l,f8l;	
	f1l = f2l = f3l = f4l = f5l = f6l = f7l = f8l = 0;
	//int num_wl=0,num_wr=0;
	//int num_hl=0,num_hr=0;
	int num_wl=0, num_hl=0;
	int x, y, ans = -1;
	uchar col = 0;
	IplImage *targetImageL;
	//IplImage *targetImageR;


	targetImageL = cvCreateImage(cvGetSize(src_l), IPL_DEPTH_8U, 1);
	targetImageL = cvCloneImage(src_l);
	num_wl = src_l->width;
	num_hl = src_l->height;

//ROI走査(0-9の判定):left 1:二値化した画像の白部分 0:二値化した画像の黒部分
	for(x = 0; x < num_wl / 2; x++){
		col = targetImageL->imageData[targetImageL->widthStep * (num_hl / 4) + x];
		if(col == 255){
			f1l = 1;
			break;
		}
	}
	for(x = num_wl - 1; x >= num_wl - num_wl / 2; x--){
		col = targetImageL->imageData[targetImageL->widthStep * (num_hl / 4) + x];
		if(col == 255){
			f2l = 1;
			break;
		}
	}
	for(x = 0; x < num_wl / 2; x++){
		col = targetImageL->imageData[targetImageL->widthStep * (3 * num_hl / 4) + x];
		if(col == 255){
			f3l = 1;
			break;
		}
	}
	for(x = num_wl - 1; x >= num_wl - num_wl / 2; x--){
		col = targetImageL->imageData[targetImageL->widthStep*(3 * num_hl / 4) + x];
		if(col == 255){
			f4l = 1;
			break;
		}
	}
	for(y = 0; y < num_hl / 4; y++){
		col = targetImageL->imageData[targetImageL->widthStep * y + (num_wl / 2)];
		if(col == 255){
			f5l = 1;
			break;
		}
	}
	for(y = num_hl - 1; y >= num_hl - num_hl / 4; y--){
		col = targetImageL->imageData[targetImageL->widthStep * y + (num_wl / 2)];
		if(col == 255){
			f6l = 1;
			break;
		}
	}
	for(y = num_hl / 4; y < 3 * num_hl / 4; y++){
		col = targetImageL->imageData[targetImageL->widthStep * y + (num_wl / 2)];
		if(col == 255){
			f7l = 1;
			break;
		}
	}
	//1と8の見分け
	//col = targetImageL->imageData[targetImageL->widthStep * num_hl / 4 + (num_wl / 2)];
	col = targetImageL->imageData[targetImageL->widthStep * num_hl * 3/ 4 + (num_wl / 2)];
	if(col == 255){
		f8l = 1;
	}

	if(f7l == 0 && (f1l&f2l&f3l&f4l&f5l&f6l) == 1)		ans=0;
	else if((f1l|f4l)==0 && (f2l&f3l&f5l&f6l&f7l)==1)	ans=2;
	else if((f1l|f3l)==0 && (f2l&f4l&f5l&f6l&f7l)==1)	ans=3;
	else if((f3l|f5l|f6l)==0 && (f1l&f2l&f4l&f7l)==1)	ans=4;
	else if((f2l|f3l)==0 && (f1l&f4l&f5l&f6l&f7l)==1)	ans=5;
	else if(f2l==0 && (f1l&f3l&f4l&f5l&f6l&f7l)==1)		ans=6;
	else if((f3l|f6l|f7l)==0 && (f1l&f2l&f4l&f5l)==1)	ans=7;
	else if(f3l==0 && (f1l&f2l&f4l&f5l&f6l&f7l)==1)		ans=9;
	else if(f8l==0 && (f1l&f2l&f3l&f4l&f5l&f6l&f7l)==1)	ans=8;
	else if((f1l&f2l&f3l&f4l&f5l&f6l&f7l&f8l)==1)		ans=1;

	*num_l=ans;

	cvReleaseImage(&targetImageL);
}

