#include<stdio.h>
#include<unistd.h>
#include <linux/errno.h>
#include <pthread.h>
#include <sys/io.h>

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <string.h>

#include "hardware.h"
#include "direction.h"
#include "run_ctrl.h"
#include "vel_ctrl.h"
#include "number.h"
#include "io.h"

#define time 3000000	//3[s]
#define regetTime 5000000 	//リゲットタイム5[s]
#define j 1	//ループ


/*int io(char io_data[]){
	char io[12]={1,0,0,0,0,0,0,0,0,0,0,0};
	int i=0;
	printf("12bitの２進数を入力してください。\n");
	while(i<12){
		scanf("%d",&io[i]);
		io_data[i]=io[i];
		i++;
	}
	for(i=0;i<12;i++){
		io_data[i]=io[i];
		printf("%d",io_data[i]);
	}
	printf("\n");

	return 0;
}*/

int tracking(void){
	int T=0;
	int i=0;
	while(T<j){	//Tがj以下のとき以下の文をループする
		int data[12];
		char io_data[12];
		io_get(io_data);	//ioからデータをもらう
		for(i=0;i<12;i++){	//もらったデータをchar型からint型へ変換
			data[i]=/*atoi(*/(int)io_data[i]/*)*/;
		}
		int io2=1;
		for(i=0;i<=3;i++){		//データをswitch文で使える形にする。
			io2=io2*10;
			io2=io2+data[i];
		}
		//printf("%d\n",io2 );
		io2=io2-10000;
		switch(io2){
			case 0000:		//赤外線センサ反応なし
				vel_ctrl_set(0.0, 0.0);
				T++;
				usleep(regetTime);
				break;
			case 1000:		//前のみ反応
				vel_ctrl_set(10.0, 10.0);
				usleep(time);
				break;
			case 1100:		//前と左が反応
				vel_ctrl_set(5.0, 10.0);
				usleep(time);
				break;
			case 0100:		//左のみ反応
				vel_ctrl_set(-10.0, 10.0);
				usleep(time);
				break;
			case 0110:		//後ろと左が反応
				vel_ctrl_set(-5.0, -10.0);
				usleep(time);
				break;
			case 0010:		//後ろのみ反応
				vel_ctrl_set(-10.0, -10.0);
				usleep(time);
				break;
			case 0011:		//後ろと右が反応
				vel_ctrl_set(-10.0, -5.0);
				usleep(time);
				break;
			case 0001:		//右のみが反応
				vel_ctrl_set(10.0, -10.0);
				usleep(time);
				break;
			case 1001:		//前と右が反応
				vel_ctrl_set(10.0, 5.0);
				usleep(time);
				break;
			
		}
	}
	return 1;
}

