/*
デバイスファイルをOpen/Closeするモジュール
2014/07/14	by S.Ushimaru
*/
#include <linux/errno.h>
#include <sys/io.h>
#include <unistd.h>
#include <math.h>
#include <time.h>
#include <pthread.h>
#include <stdio.h>
#include <fcntl.h>
#include "device.h"

static int fd_encoder;
static int fd_motor;
static int fd_uss;
static int fd_io;

int device_encoder_open(){

        //fd_encoder=open("/dev/mg3_encoder_dev",O_RDWR);
        fd_encoder=open("/dev/encoder_dev",O_RDWR);
        printf("fd_encoder=%d\n",fd_encoder);
        if(fd_encoder==-1){
                printf("encoder_dev can't open !!!\n");
                return -1;
        }
                return 0;

}

int device_motor_open(){

        //fd_motor=open("/dev/mg3_motor_dev",O_RDWR);
        fd_motor=open("/dev/motor_dev",O_RDWR);
        printf("fd_motor=%d\n",fd_motor);
        if(fd_motor==-1){
                printf("motor_dev can't open !!!\n");
                return -1;
        }
                return 0;
}

int device_uss_open(){

	//fd_uss=open(S_PORT,O_RDWR | O_NOCTTY | O_NONBLOCK);
	fd_uss=open("/dev/ttyS0",O_RDWR | O_NOCTTY | O_NONBLOCK);
        printf("fd_uss=%d\n",fd_uss);
        if(fd_uss==-1){
                printf("uss_dev can't open !!!\n");
                return -1;
        }
                return 0;
}

int device_io_open(){

	//fd_io=open("/dev/mg3_io_dev",O_RDONLY);
	fd_io=open("/dev/io_dev",O_RDONLY);
        printf("fd_io=%d\n",fd_io);
        if(fd_io==-1){
                printf("io device can't open !!!\n");
                return -1;
        }
                return 0;
}


int device_encoder_close(){
		close(fd_encoder);
                return 0;
}
int device_motor_close(){
		close(fd_motor);
                return 0;
}
int device_uss_close(){
		close(fd_uss);
                return 0;
}
int device_io_close(){
		close(fd_io);
                return 0;
}


int device_encoder_get(){
	return fd_encoder;
}
int device_motor_get(){
	return fd_motor;
}
int device_uss_get(){
	return fd_uss;
}

int device_io_get(){
	return fd_io;
}

