//全体の制御を行う
//main
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "device.h"
#include "direction.h"
#include "encoder.h"
#include "vel_ctrl.h"
#include "sequence.h"
#include "patrol.h"
#include "tracking.h"
#include "io.h"

int main(){
	
	int mlaba;
	//デバイスオープン
	mlaba=device_encoder_open();
	mlaba=device_motor_open();
	mlaba=device_uss_open();
	mlaba=device_io_open();

	//エンコーダ、速度制御スレッドの生成
	encoder_create(); 
	vel_ctrl_create();

	int ma=0;
	printf("sequence:0 patrol:1 tracking:2\nwhere?\n");
	scanf("%d",&ma);
	while(1){
		switch (ma){
			case 0:
				printf("sequence()\n");
				ma=sequence();//タイムアタック
				break;
			case 1:
				printf("patrol()\n");
				ma=patrol();//競技場巡回
				break;
			case 2:
				printf("tracking()\n");
				ma=tracking();//捕獲
				break;
			default:
				printf("patrol()　GO！\n");
				ma=1;
		}
	}
	//#mirsak_patrol(); //巡回走行
	//#mirsac_chase(); //追跡（未実装）

	//デバイスのクローズ
	mlaba=device_encoder_close();
	mlaba=device_motor_close();
	mlaba=device_uss_close();

	return 0;

}

